Index: lib/spatial/mapbuilder/lib/widget/ButtonBase.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/ButtonBase.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/ButtonBase.js	(revision 4307)
@@ -1,72 +1,116 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: ButtonBase.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
-mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+mapbuilder.loadScript(baseDir+"/util/Util.js");
+mapbuilder.loadScript(baseDir+"/widget/WidgetBase.js");
 
 /**
- * Abstract base Button object that all Buttons extend.  
+ * Abstract base button object that all Buttons extend.  
  * A Button is a widget which renders an image and an optional second image 
  * for the enabled state.
  * @constructor
  * @base WidgetBase
  * @author Mike Adair mike.adairATccrs.nrcan.gc.ca
- * @param button Pointer to the button instance being created.
  * @param widgetNode The tool node from the Config XML file.
  * @param model The parent model object (optional).
  */
 function ButtonBase(widgetNode, model) {
+  WidgetBase.apply(this, new Array(widgetNode, model));
 
-  //stylesheet is fixed to this one
-  this.stylesheet = new XslProcessor(baseDir+"/widget/Button.xsl");
-  var buttonBarNode = widgetNode.selectSingleNode("mb:buttonBar");
-  if ( buttonBarNode ) {
-    this.htmlTagId = buttonBarNode.firstChild.nodeValue;
-  } else {
-    alert("buttonBar property required for object:" + widgetNode.nodeName );
+  this.htmlTagId = this.getProperty("mb:buttonBar");
+  if (!this.htmlTagId) {
+    this.htmlTagId = this.getProperty("mb:htmlTagId");
+  }    
+  if (!this.htmlTagId) {
+    alert(mbGetMessage("buttonBarRequired", widgetNode.nodeName));
   }
+  // Set button text values as parameters
+  if (config.widgetText) {
+    var textNodeXpath = "/mb:WidgetText/mb:widgets/mb:" + widgetNode.nodeName;
+    var textParams = config.widgetText.selectNodes(textNodeXpath+"/*");
+    for (var j=0;j<textParams.length;j++) {
+      this[textParams[j].nodeName]=getNodeValue(textParams[j]);
+    }
+  }
+  // html tag id of the div where OL places its panel code
+  this.panelHtmlTagId = this.htmlTagId+'_panel';
 
-  WidgetBaseXSL.apply(this, new Array(widgetNode, model));
+  // load controlPanel.css for button base styles
+  loadCss('controlPanel.css');
 
   //set the button type
-  this.buttonType = widgetNode.selectSingleNode("mb:class").firstChild.nodeValue;
-  if (this.buttonType == "RadioButton") this.enabled = false;
+  this.buttonType = this.getProperty("mb:class")
+  this.buttonType = this.buttonType ? this.buttonType.toUpperCase() : null;
+  if (this.buttonType == "RADIOBUTTON") this.enabled = false;
+  
+  // map between MB and OL button types
+  this.olButtonType = {
+      "RADIOBUTTON" : OpenLayers.Control.TYPE_TOOL,
+      "TOOL"        : OpenLayers.Control.TYPE_TOOL,
+      "BUTTON"      : OpenLayers.Control.TYPE_BUTTON,
+      "TOGGLE"      : OpenLayers.Control.TYPE_TOGGLE
+  }
 
+  //set the button action
+  this.action = this.getProperty("mb:action");
+  
+  // set the button tooltip
+  var tooltip = this.getProperty("mb:tooltip");
+  if (tooltip) {
+    this.tooltip = tooltip;
+  }
+
   //pre-load the button bar images; add them to the config
-  var disabledImage = widgetNode.selectSingleNode("mb:disabledSrc");
+  var disabledImage = this.getProperty("mb:disabledSrc");
   if (disabledImage) {
-    this.disabledImage = document.createElement("img");
-    this.disabledImage.src = config.skinDir + disabledImage.firstChild.nodeValue;
+    this.disabledImage = config.skinDir + disabledImage;
   }
 
   //optional second image to be displayed in the enabled state
-  var enabledImage = widgetNode.selectSingleNode("mb:enabledSrc");
+  var enabledImage = this.getProperty("mb:enabledSrc");
   if (enabledImage) {
-    this.enabledImage = document.createElement("img");
-    this.enabledImage.src = config.skinDir + enabledImage.firstChild.nodeValue;
+    this.enabledImage = config.skinDir + enabledImage;
   }
-  
+
+  this.cursor = 'default';
+
   // Check for cursor override
-  var cursorNode = this.widgetNode.selectSingleNode("mb:cursor");
-  if( cursorNode != null ) {
-    var cursor = cursorNode.firstChild.nodeValue;
-    this.cursor = cursor;
-  } else {
-    this.cursor = "default"; // Adding support for customized cursors
-  }
+  this.cursor = this.getProperty("mb:cursor");
 
+  //a button may be set as selected in the config file
+  this.selected = Mapbuilder.parseBoolean(this.getProperty("mb:selected", false));
+
   /**
-   * Override of widgetBase prePaint to set the doc to be styled as the widget
-   * node in config for this button.
-   * @param objRef Pointer to this object.
+   * Gets the css classname for this button. We use this
+   * to define the button styles.
+   * @param objRef Reference to this object.
+   * @param state 'Active' or 'Inactive' (case sensitive!)
    */
-  this.prePaint = function(objRef) {
-    objRef.resultDoc = objRef.widgetNode;
+  this.getButtonClass = function(objRef, state) {
+    var cssName;
+    if (objRef.control.displayClass) {
+      cssName = objRef.control.displayClass;
+    } else {
+      cssName = objRef.control.CLASS_NAME;
+      cssName = cssName.replace(/OpenLayers/, 'ol').replace(/\./g, '');
+    }
+    cssName += 'Item';
+    return '.' + cssName + state;
   }
 
   /**
+   * OpenLayers control for this button.
+   * This will be filled with the instance of the control
+   * by the attachToOL method.
+   */
+  this.control = null;
+
+  //TBD This is never called, but I think we can drop it
+  // if we get rid of MB mouse handlers
+  /**
    * Override this in buttons which inherit from this object to carry out the action.
    * This is the function that will be called either when the button is selected
    * via the select() method or on a mouseup event if there is an associated 
@@ -75,83 +119,200 @@
   this.doAction = function() {}
 
   /**
-   * Called when a user clicks on a this.  Switches the image to the enabled 
-   * button source, enables and disables associated tools, then calls the 
-   * doSelect method defined in derived classes.
+   * Select this button. Enables and disables associated tools,
+   * then the control.trigger()/activate() methods make OL call
+   * the doSelect method defined in derived classes.
    */
   this.select = function() {
-  
-    // Add support to change cursors in the map area based on:
-    // either user selected cursor in config file using <cursor> tag
-    // or default tool cursor as defined in constructor   
-    var a = document.getElementById("mainMapContainer");
-    if( a != null ) {
-      // default or user selected cursor
-      a.style.cursor = this.cursor;
-    }  
-       
-    if (this.buttonType == "RadioButton") {
-      if (this.node.selectedRadioButton) {
-        with (this.node.selectedRadioButton) {
-          if (disabledImage) image.src = disabledImage.src;
-          enabled = false;
-          if ( mouseHandler ) mouseHandler.enabled = false;
-          link.className = "mbButton";
-          doSelect(false,this);
-        }
-      }
-      this.node.selectedRadioButton = this;
-      if (this.enabledImage) this.image.src = this.enabledImage.src;
-      this.link.className = "mbButtonSelected";
+    if (this.control.type == OpenLayers.Control.TYPE_BUTTON) {
+      this.control.trigger();
+    } else {
+      this.panel.activateControl(this.control);
     }
-    
-    //enable this tool and any dependancies
-    this.enabled = true;
-    if ( this.mouseHandler ) this.mouseHandler.enabled = true;
-    this.doSelect(true,this);
   }
 
   /**
    * Method overriden by subclasses
+   * @param objRef Reference to this object.
    * @param selected True when selected, false when deselected.
-   * @param objRef Reference to this object.
    */
-  this.doSelect = function(selected, objRef) {
+  this.doSelect = function(objRef, selected) {
   }
-
-  //a button may be set as selected in the config file
-  var selected = widgetNode.selectSingleNode("mb:selected");
-  if (selected && selected.firstChild.nodeValue) this.selected = true;
-
+  
   /**
-   * A listener method to initialize the mouse handler, if configured.  This is
-   * called as an init event so that the object pointed to is guaranteed to 
-   * be instantiated.
+   * Attaches the control for this button to OpenLayers
+   * and add it to the buttonBar. When this method is called,
+   * everything of the OL map is available.
+   * @param {OpenLayers.Control} control to add.
    * @param objRef Reference to this object.
    */
-  this.initMouseHandler = function(objRef) {
-    /** Mouse handler which this tool will register listeners with. */
-    var mouseHandler = objRef.widgetNode.selectSingleNode("mb:mouseHandler");
-    if (mouseHandler) {
-      objRef.mouseHandler = eval("config.objects." + mouseHandler.firstChild.nodeValue);
-      if (!objRef.mouseHandler) {
-        alert("error finding mouseHandler:"+mouseHandler.firstChild.nodeValue+" for button:"+objRef.id);
+  this.attachToOL = function(objRef,refreshId) {
+    if (objRef.control) {
+      return;
+    }
+  
+    //pass in a widget ID to refresh only that widget
+    if (refreshId && (refreshId!=objRef.id)) return;
+    
+    // nothing to do here if subclass does not have a
+    // createControl method
+    if (!objRef.createControl) return;
+
+    // override the control from the subclass to add
+    // MB-stuff to the activate and deactivate methods
+    var SubclassControl = objRef.createControl(objRef);
+    var type = objRef.olButtonType[objRef.buttonType] ||
+        SubclassControl.prototype.type;
+        
+    var Control = OpenLayers.Class( SubclassControl, {
+      objRef: objRef,
+      type: type,
+      superclass: SubclassControl.prototype,
+      // call objRef.doSelect after OL activate from this control
+      trigger: function() {
+        if(this.superclass.trigger) {
+          this.superclass.trigger.call(this);
+        }
+        objRef.doSelect(objRef, true);
+      },
+      activate: function() {
+        if (this.superclass.activate.call(this)) {
+          this.panel_div.style.backgroundImage = "url(\""+objRef.enabledImage+"\")";
+      	  this.map.div.style.cursor = objRef.cursor;
+      	  // store the cursor with the map object; this will be applied
+      	  // to the map div again when setting the aoi on the
+      	  // OpenLayers moveend event
+      	  this.map.mbCursor = objRef.cursor;
+          objRef.enabled = true;
+          this.active = true;
+          objRef.doSelect(objRef, true);
+        }
+      },
+      // call objRef.doSelect after OL deactivate from this control
+      deactivate: function() {
+        if (this.superclass.deactivate.call(this)) {
+          this.panel_div.style.backgroundImage = "url(\""+objRef.disabledImage+"\")";
+          objRef.enabled = false;
+          this.active = false;
+          if (map.getControlsBy("active", true).length == 0) {
+            this.map.div.style.cursor = "";
+            this.map.mbCursor = "";
+          }
+          objRef.doSelect(objRef, false)
+        }
+      },
+      destroy: function() {
+        try {
+          this.superclass.destroy.apply(this, arguments);
+        } catch(e) {
+          OpenLayers.Control.prototype.destroy.apply(this, arguments);
+        }
+        this.superclass = null;
+        OpenLayers.Event.stopObservingElement(this.panel_div);
+        this.objRef.panel.div.removeChild(this.panel_div);
+        this.objRef.control = null;
+        this.objRef = null;
+        this.panel_div = null;
+        this.div = null;
       }
-    } else {
-      objRef.mouseHandler = null;
+    });
+
+    // if the subclass provides an instantiateControl() method,
+    // use it for instantiation. If not, instantiate directly
+    if (!objRef.control) {
+      objRef.control = objRef.instantiateControl ? objRef.instantiateControl(objRef, Control) : new Control();
     }
+    
+    // get the control from the createControl method of the subclass
+    //objRef.control = objRef.createControl(objRef);
+    var map = objRef.targetContext.map;
+    objRef.panel = objRef.targetContext.buttonBars[objRef.htmlTagId];
+    // create a panel, if we do not have one yet for this buttonBar
+    // or if the old map.panel was destroyed
+    if (!objRef.panel || objRef.panel.map == null) {
+      // create a dom node for OL to use as panel
+      if (!document.getElementById(objRef.panelHtmlTagId)) {
+        var olPanelNode = document.createElement('div');
+        olPanelNode.setAttribute('id', objRef.panelHtmlTagId);
+        olPanelNode.setAttribute('class', 'olControlPanel');
+        var parentNode = objRef.getNode();
+        parentNode.appendChild(olPanelNode);
+        parentNode.innerHTML += " ";
+      }
+      var Panel = OpenLayers.Class( OpenLayers.Control.Panel, {
+        div: document.getElementById(objRef.panelHtmlTagId),
+        defaultControl: null,
+        destroy: function() {
+          parentNode.removeChild(this.div);
+          OpenLayers.Control.prototype.destroy.apply(this, arguments);
+          this.div = null;
+          objRef.panel = null;
+        }
+      });
+      objRef.panel = new Panel();
+      objRef.targetContext.buttonBars[objRef.htmlTagId] = objRef.panel;
+      map.addControl(objRef.panel);
+    }
+    
+    // add the control to the panel
+    if (OpenLayers.Util.indexOf(objRef.control, objRef.panel.controls) == -1) {
+      // we do not want to stop event propagation. So we save the original
+      // Event.stop function...
+      var originalStop = OpenLayers.Event.stop;
+      // and overwrite it with a new one...
+      OpenLayers.Event.stop = function(){};
+      // now, thanks to boxing, this one will be assigned in addControls...
+      objRef.panel.addControls(objRef.control);
+      // and we can switch back to the original one.
+      OpenLayers.Event.stop = originalStop;
+    }
+     
+    // set tooltip for the button
+    if (objRef.tooltip) {
+      objRef.control.panel_div.title=objRef.tooltip;
+    }
+    
+    //set default css style properties
+    objRef.control.panel_div.style.backgroundImage = "url(\""+objRef.disabledImage+"\")";
+          
+    // activate the control if it is defined as selected in config
+    if(objRef.selected == true) {
+      objRef.control.activate();      
+    }    
   }
 
   /**
-   * Initialise image for the button and select it if required.
+   * Set the target context for the button, initialise the
+   * buttonBars array in the context document and add a
+   * listener to the target model for adding controls
+   * to the OL map as soon as the map is initialized.
    * @param objRef Reference to this object.
-   */
+   */  
   this.buttonInit = function(objRef) {
-    objRef.image = document.getElementById( objRef.id+"_image" );
-    objRef.link = document.getElementById( objRef.outputNodeId );
-    if (objRef.selected) objRef.select();
+     //set the target context
+    var targetContext = objRef.widgetNode.selectSingleNode("mb:targetContext");
+    if (targetContext) {
+      objRef.targetContext = window.config.objects[getNodeValue(targetContext)];
+      if ( !objRef.targetModel ) {
+        alert(mbGetMessage("noTargetContext", getNodeValue(targetContext), objRef.id));
+      }
+    } else {
+      objRef.targetContext = objRef.targetModel;
+    }
+    
+    // initialize button bars for the context
+    if (!objRef.targetContext.buttonBars) {
+      // this array in the context will hold all
+      // buttonBars used by button widgets
+      objRef.targetContext.buttonBars = new Array();
+    }
+    
+    // add another event listener for the loaded context,
+    // because we need the map to add panel and buttons,
+    // and we do not have tha map yet
+    objRef.targetContext.addListener("refresh", objRef.attachToOL, objRef);
   }
 
-  this.model.addListener("refresh",this.buttonInit,this);
-  this.model.addListener("init", this.initMouseHandler, this);
+  this.model.addListener("init",this.buttonInit,this);
+  this.model.removeListener("newNodel", this.clearWidget, this);
 }
Index: lib/spatial/mapbuilder/lib/widget/MapTitle.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/MapTitle.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/MapTitle.js	(revision 4307)
@@ -0,0 +1,18 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: MapTitle.js 2546 2007-01-23 12:07:39Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Displays the Title value from a Web Map Context document.
+ * @constructor
+ * @base WidgetBaseXSL
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function MapTitle(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+}
Index: lib/spatial/mapbuilder/lib/widget/TipWidgetConfig.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/TipWidgetConfig.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/TipWidgetConfig.js	(revision 4307)
@@ -0,0 +1,30 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: TipWidgetConfig.js 3879 2008-02-27 14:20:29Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/TipWidgetBase.js");
+
+/**
+ * Configuration for TipWidgetOL and similar widgets.
+ * @base TipWidgetBase
+ * @author Andreas Hocevar andreas.hocevarATgmail.com
+ * @param widgetNode      The widget node from the Config XML file.
+ * @param model  The FeatureCollection model.
+ */
+function TipWidgetConfig(widgetNode, model) {
+  TipWidgetBase.apply(this, new Array(widgetNode, model));
+  
+  var targetWidget = this.getProperty('mb:targetWidget');
+  
+  this.init = function(objRef) {
+    if (targetWidget) {
+      if (!model.config) {
+        model.config = new Array();
+      }
+      model.config[targetWidget] = objRef.config;
+    }
+  }
+  model.addListener('init', this.init, this);
+}
Index: lib/spatial/mapbuilder/lib/widget/Back.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Back.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Back.js	(revision 4307)
@@ -1,7 +1,7 @@
 /*
 Author:       Steven Ottens AT geodan.nl
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Back.js 3587 2007-11-12 12:24:58Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -16,23 +16,33 @@
  * @param model  The model for this widget
  */
 function Back(widgetNode, model) {
-  ButtonBase.apply(this, new Array(widgetNode, model));
+ 
+   ButtonBase.apply(this, new Array(widgetNode, model));
 
   /**
-   * Replaces the current extent with the previous one in history
-   * @param objRef      Pointer to this object.
+   * Interactive ZoomOut control.
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} instance of the OL control.
    */
-  this.doSelect = function(selected,objRef) {
-    if (selected){
-
-		this.targetModel.setParam("historyBack");
-      var previousExtent = objRef.targetModel.previousExtent;
-      if(previousExtent){
-        this.targetModel.setParam("historyStop");
-        objRef.targetModel.extent.zoomToBox( previousExtent[0], previousExtent[1] );
-        this.targetModel.setParam("historyStart");
-      }
-    }
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class( OpenLayers.Control, {
+      type: OpenLayers.Control.TYPE_BUTTON,
+      
+      trigger: function() {
+              var objRef = this.objRef;
+              objRef.targetModel.setParam("historyBack");
+              var previousExtent = objRef.targetModel.previousExtent;
+              if(previousExtent){
+                objRef.targetModel.setParam("historyStop");
+                this.map.setCenter(previousExtent.center);
+                this.map.zoomToScale(previousExtent.scale);
+                objRef.targetModel.setParam("historyStart");
+              }
+      },
+      
+      CLASS_NAME: 'mbControl.Back'
+    });
+    return Control;
   }
 }
 
Index: lib/spatial/mapbuilder/lib/widget/TransactionResponse.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/TransactionResponse.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/TransactionResponse.js	(revision 4307)
@@ -2,7 +2,7 @@
 Author:       Cameron Shorter
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: TransactionResponse.js 1671 2005-09-20 02:37:54Z madair1 $
 */
 
 // Ensure this object's dependancies are loaded.
Index: lib/spatial/mapbuilder/lib/widget/ServiceRegistryList.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/ServiceRegistryList.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/ServiceRegistryList.js	(revision 4307)
@@ -2,7 +2,7 @@
 Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: ServiceRegistryList.js 3091 2007-08-09 12:21:54Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -13,7 +13,7 @@
  * TBD: not compelted yet.
  *
  * @constructor
- * @base WidgetBase
+ * @base WidgetBaseXSL
  * @param widgetNode This widget's object node from the configuration document.
  * @param model The model that this widget is a view of.
  */
Index: lib/spatial/mapbuilder/lib/widget/AoiMetacatQuery.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/AoiMetacatQuery.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/AoiMetacatQuery.js	(revision 4307)
@@ -5,6 +5,7 @@
 
 // Ensure this object's dependancies are loaded.
 mapbuilder.loadScript(baseDir+"/widget/ButtonBase.js");
+mapbuilder.loadScript(baseDir+"/util/openlayers/OpenLayers.js");
 
 /**
  * When this button is selected, clicks on the MapPane trigger a Metacat query with the 
@@ -16,88 +17,101 @@
  * @param model  The model for this widget
  */
 function AoiMetacatQuery(widgetNode, model) {
-  // Extend ButtonBase
-  ButtonBase.apply(this, new Array(widgetNode, model))
+	// Extend ButtonBase
+	ButtonBase.apply(this, new Array(widgetNode, model))
+	
+	// Grab the important values from the config file
+	var metacat = widgetNode.selectSingleNode("mb:metacat").firstChild.nodeValue;
+	var skin = widgetNode.selectSingleNode("mb:skin").firstChild.nodeValue;
+	var tolerance = widgetNode.selectSingleNode("mb:pixel_tolerance").firstChild.nodeValue;
 
-  // Grab the important values from the config file
-  var metacat = widgetNode.selectSingleNode("mb:metacat").firstChild.nodeValue;
-  var skin = widgetNode.selectSingleNode("mb:skin").firstChild.nodeValue;
-  var tolerance = widgetNode.selectSingleNode("mb:pixel_tolerance").firstChild.nodeValue;
+	var method = "popup";
 
-  /**
-   * Queries metacat and displays the result in a popup window.
-   * @param objRef      Pointer to this object.
-   * @param targetNode  The node for the enclosing HTML tag for this widget.
-   */
-  this.doAction = function(objRef,targetNode) {
-    if (objRef.enabled) {
-      var method = "popup";
-      var bbox = objRef.targetModel.getParam("aoi");
-      if ( bbox!=null) {
-        var ul = bbox[0];
-        var lr = bbox[1];
-        var extent = objRef.targetModel.extent;
-        var extbox = extent.model.getBoundingBox();
-        var mapwidth_real = extbox[2] - extbox[0];
-        var mapwidth_pixel = extent.model.getWindowWidth();
-        var res = mapwidth_real / mapwidth_pixel;
-      }
+	this.cursor = 'crosshair';
 
-      //var selectedLayer = objRef.context.getParam("selectedLayer");
-       
+	this.createControl = function(objRef) {
+		var Control = 
+			OpenLayers.Class(OpenLayers.Control, {
+			    /**
+			     * Property: type
+			     * {OpenLayers.Control.TYPE}
+			     */
+			    type: OpenLayers.Control.TYPE_TOOL,
+			
+			    /**
+			     * Property: out
+			     * {Boolean} Should the control be used for zooming out?
+			     */
+			    out: false,
+			
+			    /**
+			     * Method: draw
+			     */    
+			    draw: function() {
+			        this.handler = new OpenLayers.Handler.Box( this,
+			                            {done: this.zoomBox}, {keyMask: this.keyMask} );
+			    },
+			
+			    /**
+			     * Method: zoomBox
+				 * Queries metacat and displays the result in a popup window.
+			     * Parameters:
+			     * position - {<OpenLayers.Bounds>} or {<OpenLayers.Pixel>}
+			     */
+			    zoomBox: function (position) {
 
-     // Determine the BBOX
-     var x1 = ul[0];
-     var y1 = lr[1];
-     var x2 = lr[0];
-     var y2 = ul[1];
-     if ( x1 == x2 && y1 == y2 ) {
-      // BBOX is really a point; give a bit of wiggle room
-      // tolerance is number of pixels to buffer, set in config
-      x1 = x1 - tolerance * res;
-      y1 = y1 - tolerance * res;
-      x2 = x2 + tolerance * res;
-      y2 = y2 + tolerance * res;          
-     } 
+			        if (position instanceof OpenLayers.Bounds) {
+		                var minXY = this.map.getLonLatFromPixel(
+		                            new OpenLayers.Pixel(position.left, position.bottom));
+		                var maxXY = this.map.getLonLatFromPixel(
+		                            new OpenLayers.Pixel(position.right, position.top));
+		                var bounds = new OpenLayers.Bounds(minXY.lon, minXY.lat,
+		                                               maxXY.lon, maxXY.lat);
+		                                               
+			            //alert("bounds:" + bounds);
 
-     var url = metacat + "?action=spatial_query&xmin=" + x1 + "&xmax=" + x2 + 
-              "&ymin=" + y1 + "&ymax=" + y2 + "&skin=" + skin;
+			            // Determine the BBOX
+						var x1 = bounds.left;
+						var y1 = bounds.bottom;
+						var x2 = bounds.right;
+						var y2 = bounds.top;
+			        } else { // it's a pixel
+			        	
+			        	var minXY = this.map.getLonLatFromPixel(
+		                            new OpenLayers.Pixel(position.x, position.y));
+			        	var x1 = minXY.lon;
+						var y1 = minXY.lat;
+						var x2 = minXY.lon;
+						var y2 = minXY.lat;
+			        }
 
-     if (method == 'popup') {
-       newwindow = window.open(url,'queryWin',
-                  'height=600,width=800,status=yes,toolbar=yes,menubar=no,location=yes,resizable=yes,scrollbars=yes');
-       if (window.focus) {newwindow.focus()}
-     }
-
-    }
-  }
-
-  /**
-   * Register for mouseUp events.
-   * @param objRef  Pointer to this object.
-   */
-  this.setMouseListener = function(objRef) {
-    if (objRef.mouseHandler) {
-      objRef.mouseHandler.model.addListener('mouseup',objRef.doAction,objRef);
-    }
-    objRef.context=objRef.widgetNode.selectSingleNode("mb:context");
-    if (objRef.context){
-      alert("got context!");
-      objRef.context=eval("config.objects."+objRef.context.firstChild.nodeValue);
-    } else {
-		//alert("no context in AoiMetacatQuery widget.  using mainMap ");
-		objRef.context=eval("config.objects.mainMap");
-		/*
-		var nodes = objRef.widgetNode.childNodes;
-    	for (var i=0; i<nodes.length; i++) {
-    		alert(nodes.item(i).nodeType + " // " +
-    		nodes.item(i).nodeName + " // " +
-    		nodes.item(i).nodeValue);
-		}
-		*/
+					if ( x1 == x2 && y1 == y2 ) {
+						// BBOX is really a point; give a bit of wiggle room
+						// tolerance is number of pixels to buffer, set in config
+			        	var extent = this.map.getExtent();
+				    	var res = extent.getWidth() / this.map.size.w;
+				    	//alert("res:" + res);
+						x1 = x1 - tolerance * res;
+						y1 = y1 - tolerance * res;
+						x2 = x2 + tolerance * res;
+						y2 = y2 + tolerance * res;          
+					} 
+					
+					var url = metacat + "?action=spatial_query&xmin=" + x1 + "&xmax=" + x2 + 
+					         "&ymin=" + y1 + "&ymax=" + y2 + "&skin=" + skin;
+					
+					if (method == 'popup') {
+					  newwindow = window.open(url,'queryWin',
+					             'height=600,width=800,status=yes,toolbar=yes,menubar=no,location=yes,resizable=yes,scrollbars=yes');
+					  if (window.focus) {newwindow.focus()}
+					}
+			        
+			    },
+			
+			    CLASS_NAME: "mbControl.AoiMetacatQuery"
+			});
+			
+		return Control;
 	}
-  }
-  this.model.addListener( "loadModel", this.setMouseListener, this );
-
 }
 
